	PAGE	60,120

;  Sound generation routine for Microsoft Fortran, large model.
;  Could make zero freq just produce delay, but code would be ugly.
;  Writtten May 1992 by Robert Thrun for Masm 5.0
;  Not copyrighted or legally restricted in any way.

;     CALL TTONE (IFREQ, IDUR) is calling sequence.
;        IFREQ -- frequency of sound in Hz
;        IDUR --- duration of sound in clock ticks (18.2 ticks/sec)

	.MODEL	LARGE	; Interface with large model Fortran prog.
	PUBLIC	TTONE

	.CODE
TTONE	PROC	FAR
	push	bp
	mov	bp, sp
	push	ds

; Set the timer to be a square wave generator.
	mov	al, 0B6h	; control word
	out	43h, al		; control port

; Set the frequency.
	les	bx, [bp+10]	; first arg, IFREQ 
	mov	cx, es:[bx]	; sound frequency
	mov 	dx, 12h		; 1,193,182 Hz clock to
	mov	ax, 34DEh	; DX:AX register pair.
	div	cx		; Divide by frequency, result to AX.
	out	42h, al		; low byte of period in clock cycles
	xchg	ah, al
	out	42h, al		; high byte of period to timer

; Wait for the first clock change.
	xor	ax, ax
	mov	ds, ax
	mov	al, ds:46Ch	; Dword at 40:006C is
t1:	cmp	al, ds:46Ch	; incremented every clock tick.
	je	t1		; wait for change

; Turn the sound on.
	in	al, 61h		; timer port B
	or	al, 3		; low two bits control sound
	out	61h, al

; Make a delay. Count down the number of clock ticks.
	les	bx, [bp+6]	; second argument, IDUR
	mov	cx, es:[bx]	; cx = number of ticks for sound
	cmp	cx, 0		; Otherwise, zero duration rolls
	je	t4		; over to 64K ticks, about 1 hour.
t2:	mov	al, ds:46Ch
t3:	cmp	al, ds:46Ch	; keep checking for change
	je	t3
	loop	t2		; decrement cx, then test

; Turn the sound off.
t4:	in	al, 61h		; timer port B
	and	al, 0FCh	; set the low two bits to zero
	out	61h, al

	pop	ds
	pop	bp
	ret	8		; to calling Fortran program

TTONE	ENDP
	END
